%script for decorrelating accelerometer data series 4 to 17; 18 to 30; 31 to 44
%import file Ax_2010_04to17, take column 1 for Ax and column 2 for T
%import file Ax_2010_18to30, take column 1 for Ax2 and column 2 for T2

%import file Ax_2010_31to44, take column 1 for A3 and column 2 for T3
%note that for series 31 to 44 recordings have been interrupted for about
%15 minutes and the accelerator changed of plane; this means new average
%value has to be compensated to be compared with other series; note also
%that a shift of 15 minutes has been applied
%script for decorrelating serie 
%import file Ax_2010_31to44, which contains Ax3 and T3


%average value btw 4 to 30 is -2372.1
%average value btw 43860 to last value is -1422.9
deltav = 949.2;

clear('At');
clear('newAx');
clear('newT');

n1 = size(Ax)
n2 = size(Ax2)
ntot = n1+n2
sample = 72000;
f = 2/32768 * 1000; %milli g
deltat = 1/sample;
t= 0;
av = 0;
for i=1:n1
    At(i) = t;
    newAx(i) = f * Ax(i);
    av = av + Ax(i);
    newT(i) = T(i);
    t = t+deltat;
end
for i=n1+1:n1+n2
    At(i) = t;
    j = i-n1;
    j = j(1);
    newAx(i) = f * Ax2(j);
    av = av + Ax2(j);
    newT(i) = T2(j);
    t = t+deltat;
end
av = av / ntot(1)
n3 = 24600;

for i=n1+n2+1:n1+n2+n3
    At(i) = t;
    j = i-n1-n2;
    j = j(1);
    newAx(i) = f * Ax3(j);
    newT(i) = T3(j);
    t = t+deltat;
end
size(newT)

n4 = size(Ax3)
nstart = 43860;
clear('j');
j = nstart
i = n1+n2+n3+1;
ii = i(1)
while j < n4(1)
    At(ii) = t;
    newAx(ii) = f * (Ax3(j)-deltav);
    newT(ii) = T3(j);
    ii = ii + 1;
    j = j + 1;
    t = t+deltat;
end
ntot = ii-1  


cla
clear('g');
clear('G');
clear('lp');
 
%plot(At,newAx);
%ylabel('Ax (mg)','fontsize',14) 

%plot(At,newT)
%ylabel('T (deg C)','fontsize',14)



Y = fft(newAx);
H = fft(newT);
for ii=1:ntot G(ii) = Y(ii) / H(ii); end
g= ifft(G); 
g(1) = 0;
%plot(At,g)

% Plot single-sided amplitude spectrum.
%G(1)=0;
%freq = 100/2*linspace(0,1,n/2+1);
%plot(freq,2*abs(G(1:n/2+1))) 

%filterbuilder
%Fpass = 0.01;  % Passband Frequency
%Fstop = 0.05;  % Stopband Frequency
%Apass = 1;    % Passband Ripple (dB)
%Astop = 60;   % Stopband Attenuation (dB)


lp = lowpass4(g);
%lp = g;

clear('nlp');
clear('nt');
clear('nAx');
clear('nT');
clear('ng');
samp = 1200*2;
deltat = samp / 20 / 3600;
t = 0;
j=1;
for i=1:samp:ntot-samp
    s = 0;
    s2 = 0;
    s3 = 0;
    s4 = 0;
    for k=i:i+samp
        s = s + lp(k);
        s2 = newAx(k);
        s3 = newT(k);
        s4 = s4 + g(k);
    end
    nlp(j) = s/samp;
    nAx(j) = s2;
    nT(j) = s3;
    ng(j) = s4/samp;
    nt(j) = t;
    t = t + deltat;
    j = j + 1;
end

%plot(nt,nAx);
%axis([0 40 -147 -140])
%ylabel('Ax (mg)','fontsize',14)
%plot(nt,nT)
%axis([0 40 12 32])
%ylabel('T (deg C)','fontsize',14)
%plot(nt,ng)
%axis([0 40 -2e-5 2e-5])
%plot(At,lp)
plot(nt,nlp);


clear('x');
clear('y');
clear('xx');
clear('yy');

m = size(nt);
tick = 40/m(2);

p = 5.5;
angle = -100;
alpha = angle * pi / 180;
time = 0;
ii = 1;
while time < 15
    x(ii) = nt(ii);
    y(ii) = 0.000001*sin(pi/p*x(ii)+alpha)-0.000003;
    time = time + tick;
    ii = ii + 1;
end
while time < 22
    time = time + tick;
    ii = ii + 1;
end   

p = 5.5;
angle = 60;
alpha = angle * pi / 180;
iii = 1;
while time < 40
    xx(iii) = nt(ii);
    yy(iii) = 0.000001*sin(pi/p*xx(iii)+alpha)-0.000003;
    time = time + tick;
    ii = ii + 1;
    iii = iii + 1;
end
   
hold on
plot(x,y,'--','Color','red','LineWidth',2)
plot(xx,yy,'--','Color','red','LineWidth',2)
axis([0 40 -1.5e-5 0.5e-5])
ylabel('Ax (a.u.)','fontsize',14)
xlabel('Time (hour)','fontsize',14)